Arch precast concrete tools

Info about new community or project announcements, implemented features, classes, modules or APIs. Might get technical!
PLEASE DO NOT POST HELP REQUESTS OR OTHER DISCUSSIONS HERE!
Forum rules
Be nice to others! Respect the FreeCAD code of conduct!
User avatar
yorik
Founder
Posts: 13640
Joined: Tue Feb 17, 2009 9:16 pm
Location: Brussels
Contact:

Arch precast concrete tools

Post by yorik »

The Arch Structure tool has now been extended with a series of new presets to build precast concrete elements like these:
arch_precast_example.jpg
arch_precast_example.jpg (203.74 KiB) Viewed 5739 times
This is all available from the structure creation tool, one just has to select the "precast concrete" preset, there are currently 5 available items: beam, pillar, I-beam, slab and panel. Of course, the settings are all parametric.

Enjoy!
Attachments
precast examples.FCStd
(62.92 KiB) Downloaded 125 times
User avatar
chakkree
Posts: 327
Joined: Tue Jun 30, 2015 12:58 am
Location: Bangkok Thailand

Re: Arch precast concrete tools

Post by chakkree »

+1
Excellent!
triplus
Veteran
Posts: 9471
Joined: Mon Dec 12, 2011 4:45 pm

Re: Arch precast concrete tools

Post by triplus »

Nice feature!
User avatar
chakkree
Posts: 327
Joined: Tue Jun 30, 2015 12:58 am
Location: Bangkok Thailand

Re: Arch precast concrete tools

Post by chakkree »

Test Export Precast Object to IFC.
Export_Precast_IFC.png
Export_Precast_IFC.png (132.33 KiB) Viewed 5470 times
Tested on:
OS: Windows 10
Word size of OS: 64-bit
Word size of FreeCAD: 64-bit
Version: 0.17.7731 (Git)
Build type: Release
Branch: master
Hash: dea884ab6a4a748cd61cb593ee91f0eef1bdb603
Python version: 2.7.8
Qt version: 4.8.7
Coin version: 4.0.0a
OCC version: 6.8.0.oce-0.17
Attachments
Test_Precast4.ifc
(107.1 KiB) Downloaded 111 times
User avatar
yorik
Founder
Posts: 13640
Joined: Tue Feb 17, 2009 9:16 pm
Location: Brussels
Contact:

Re: Arch precast concrete tools

Post by yorik »

Hm still some problems apparently :D
I have many problems recently with extrusions in IFC... it seems that the missing objects are all extrusions. I'll have a better look.
User avatar
chakkree
Posts: 327
Joined: Tue Jun 30, 2015 12:58 am
Location: Bangkok Thailand

Re: Arch precast concrete tools

Post by chakkree »

Test Create ArchPrecast with Macro.

Code: Select all

"""
  for Test Create ArchPrecast
"""

import FreeCAD
from ArchPrecast import _PrecastBeam , _ViewProviderPrecast
from ArchPrecast import _PrecastIbeam
from ArchPrecast import _PrecastSlab
from ArchPrecast import _PrecastPanel
from ArchPrecast import _PrecastPillar

def makePrecastBeam(Length = 3800 , Width=200 ,Height = 400):
    a=FreeCAD.ActiveDocument.addObject("Part::FeaturePython","Precast Beam")
    _PrecastBeam(a)
    _ViewProviderPrecast(a.ViewObject)
    
    a.DentLength = 200
    a.DentHeight = 200
    a.Chamfer = 18
    
    a.Length = Length
    a.Width=Width
    a.Height = Height
    return a

def makePrecastIbeam(Length = 3800 , Width=200 ,Height = 400):
    a=FreeCAD.ActiveDocument.addObject("Part::FeaturePython","Precast I Beam")
    _PrecastIbeam(a)
    _ViewProviderPrecast(a.ViewObject)

    a.BeamBase = 100
    a.Chamfer=50

    a.Length = Length
    a.Width=Width
    a.Height = Height

    return a

def makePrecastSlab(Length = 3800 , Width=1000 ,Height = 300):
    a=FreeCAD.ActiveDocument.addObject("Part::FeaturePython","Precast Slab")
    _PrecastSlab(a)
    _ViewProviderPrecast(a.ViewObject)

    a.SlabBase = 100

    a.Length = Length
    a.Width=Width
    a.Height = Height

    return a


def makePrecastPanel(Length = 3800 , Width=300 ,Height = 40):
    a=FreeCAD.ActiveDocument.addObject("Part::FeaturePython","Precast Panel")
    _PrecastPanel(a)
    _ViewProviderPrecast(a.ViewObject)

    a.Length = Length
    a.Width=Width
    a.Height = Height

    return a

def makePrecastPillar(Length = 300 , Width=300 ,Height = 4000):
    a=FreeCAD.ActiveDocument.addObject("Part::FeaturePython","Precast Pillar")
    _PrecastPillar(a)
    _ViewProviderPrecast(a.ViewObject)

    a.Length = Length
    a.Width=Width
    a.Height = Height

    return a   

B1 = makePrecastBeam()
B1.Label= 'PrecastBeam'
B1.Placement.Base.y=1000

B2 = makePrecastIbeam()
B2.Placement.Base.y=2000

S1 = makePrecastSlab()
S1.Placement.Base.y=3000
S1.HoleSpacing = 200
S1.HoleMajor=100
S1.HoleMinor=100
S1.HoleNumber = 3

S2 = makePrecastPanel()
S2.Placement.Base.y=4500

C1 = makePrecastPillar()

FreeCAD.ActiveDocument.recompute()
TestCreateArchPrecast.PNG
TestCreateArchPrecast.PNG (25.95 KiB) Viewed 5432 times
Tested on:
OS: Windows 10
Word size of OS: 64-bit
Word size of FreeCAD: 64-bit
Version: 0.17.7731 (Git)
Build type: Release
Branch: master
Hash: dea884ab6a4a748cd61cb593ee91f0eef1bdb603
Python version: 2.7.8
Qt version: 4.8.7
Coin version: 4.0.0a
OCC version: 6.8.0.oce-0.17
User avatar
chakkree
Posts: 327
Joined: Tue Jun 30, 2015 12:58 am
Location: Bangkok Thailand

Re: Arch precast concrete tools

Post by chakkree »

Test Export ArchPrecast Object to IFC.
Clone of ArchPrecastSlabBeam can export to IFC.
------------------------------------------
Clone of ArchPrecastSlab can not export to IFC.
TestCreateArchPrecast2.PNG
TestCreateArchPrecast2.PNG (288.94 KiB) Viewed 4666 times
User avatar
yorik
Founder
Posts: 13640
Joined: Tue Feb 17, 2009 9:16 pm
Location: Brussels
Contact:

Re: Arch precast concrete tools

Post by yorik »

Thanks for testing!
I made some small changes to the Precast stuff after that file was made, I had to change it a little bit. Now it works:
screenshot.jpg
screenshot.jpg (103.41 KiB) Viewed 4649 times
Attachments
precast examples.FCStd
(59.3 KiB) Downloaded 87 times
User avatar
bitacovir
Veteran
Posts: 1570
Joined: Sat Apr 19, 2014 6:23 am
Contact:

Re: Arch precast concrete tools

Post by bitacovir »

it is great! Good work!

But I noticed one thing that can be confuse.

1) the default beam, panel, pillar all have Height 1,000mm; length 100mm; Width 100mm. I think for beam should be height 300mm width 300mm and length 3,000mm And for pillar height 2000mm, width 200mm length 200mm (or something like that).
::bitacovir::
==================
One must be absolutely modern.
Arthur Rimbaud (A Season in Hell -1873)

Canal Youtube Grupo Telegram de FreeCAD Español

My personal web site
My GitHub repository
Mini Airflow Tunnel Project
User avatar
yorik
Founder
Posts: 13640
Joined: Tue Feb 17, 2009 9:16 pm
Location: Brussels
Contact:

Re: Arch precast concrete tools

Post by yorik »

It uses the default structure settings in preferences->Arch->defaults. The idea is that you set a default for a column, or a beam, and then on creation you use the "switch X/Z" button to quickly invert these values when making a horizontal or vertical element...

Of course there is space for improvement there, but I didn't want too complex preferences settings, this seemed a good and flexible way...
Post Reply